// Code generated by protoc-gen-go-rsn. DO NOT EDIT.
// versions:
// - protoc-gen-go-rsn (devel)
// - protoc            v4.25.1

package messagingrsn

import (
	errors "errors"
	fmt "fmt"
	regexp "regexp"
)

// MessageParentType indicates the possible parent types for resource 'Message'.
type MessageParentType = string

const (
	// UserMessageParentType is a possible parent type for resource 'Message', used for 'user'.
	UserMessageParentType MessageParentType = "user"
	// UserContextMessageParentType is a possible parent type for resource 'Message', used for 'userContext'.
	UserContextMessageParentType MessageParentType = "userContext"
	// OrganisationMessageParentType is a possible parent type for resource 'Message', used for 'organisation'.
	OrganisationMessageParentType MessageParentType = "organisation"
	// OrganisationSharedMailboxMessageParentType is a possible parent type for resource 'Message', used for 'organisationSharedMailbox'.
	OrganisationSharedMailboxMessageParentType MessageParentType = "organisationSharedMailbox"
)

// MessageParentRef is the representation of a 'Message' parent resource name.
// This contains all possible identifiers for all parent types. The Type field implicitly declares the
// identifiers used for that context.
type MessageParentRef struct {
	ContextId       string
	OrganisationId  string
	SharedMailboxId string
	UserId          string
	Type            MessageParentType
}

// ResourceName formats r to a resource name.
func (r MessageParentRef) ResourceName() string {
	switch r.Type {
	case UserMessageParentType:
		return fmt.Sprintf("users/%s", r.UserId)
	case UserContextMessageParentType:
		return fmt.Sprintf("users/%s/contexts/%s", r.UserId, r.ContextId)
	case OrganisationMessageParentType:
		return fmt.Sprintf("organisations/%s", r.OrganisationId)
	case OrganisationSharedMailboxMessageParentType:
		return fmt.Sprintf("organisations/%s/sharedMailboxes/%s", r.OrganisationId, r.SharedMailboxId)
	}
	return ""
}

// IsZero reports whether r represents the zero resource reference.
func (r MessageParentRef) IsZero() bool {
	return len(r.ContextId) != 0 && len(r.OrganisationId) != 0 && len(r.SharedMailboxId) != 0 && len(r.UserId) != 0 && len(r.Type) != 0
}

var (
	userMessageParentPattern                      = regexp.MustCompile(`^users/([^/]+)$`)
	userContextMessageParentPattern               = regexp.MustCompile(`^users/([^/]+)/contexts/([^/]+)$`)
	organisationMessageParentPattern              = regexp.MustCompile(`^organisations/([^/]+)$`)
	organisationSharedMailboxMessageParentPattern = regexp.MustCompile(`^organisations/([^/]+)/sharedMailboxes/([^/]+)$`)
)

// ParseMessageParentResourceName parses the given parent resource name to a parent resource reference.
// Errors for unknown patterns.
func ParseMessageParentResourceName(resourceName string) (MessageParentRef, error) {
	if match := userMessageParentPattern.FindStringSubmatch(resourceName); match != nil {
		return MessageParentRef{
			UserId: match[1],
			Type:   UserMessageParentType,
		}, nil
	}
	if match := userContextMessageParentPattern.FindStringSubmatch(resourceName); match != nil {
		return MessageParentRef{
			UserId:    match[1],
			ContextId: match[2],
			Type:      UserContextMessageParentType,
		}, nil
	}
	if match := organisationMessageParentPattern.FindStringSubmatch(resourceName); match != nil {
		return MessageParentRef{
			OrganisationId: match[1],
			Type:           OrganisationMessageParentType,
		}, nil
	}
	if match := organisationSharedMailboxMessageParentPattern.FindStringSubmatch(resourceName); match != nil {
		return MessageParentRef{
			OrganisationId:  match[1],
			SharedMailboxId: match[2],
			Type:            OrganisationSharedMailboxMessageParentType,
		}, nil
	}
	return MessageParentRef{}, errors.New("invalid parent resource name for resource type 'Message' in service 'messaging.simonbos.be'")
}

// MessageRef is the representation of a 'Message' resource name.
type MessageRef struct {
	Parent    MessageParentRef
	MessageId string
}

// ResourceName formats r to a resource name.
func (r MessageRef) ResourceName() string {
	switch r.Parent.Type {
	case UserMessageParentType:
		return fmt.Sprintf("users/%s/messages/%s", r.Parent.UserId, r.MessageId)
	case UserContextMessageParentType:
		return fmt.Sprintf("users/%s/contexts/%s/messages/%s", r.Parent.UserId, r.Parent.ContextId, r.MessageId)
	case OrganisationMessageParentType:
		return fmt.Sprintf("organisations/%s/messages/%s", r.Parent.OrganisationId, r.MessageId)
	case OrganisationSharedMailboxMessageParentType:
		return fmt.Sprintf("organisations/%s/sharedMailboxes/%s/messages/%s", r.Parent.OrganisationId, r.Parent.SharedMailboxId, r.MessageId)
	}
	return ""
}

// IsZero reports whether r represents the zero resource reference.
func (r MessageRef) IsZero() bool {
	return r.Parent.IsZero() && len(r.MessageId) != 0
}

var (
	userMessageRefPattern                      = regexp.MustCompile(`^users/([^/]+)/messages/([^/]+)$`)
	userContextMessageRefPattern               = regexp.MustCompile(`^users/([^/]+)/contexts/([^/]+)/messages/([^/]+)$`)
	organisationMessageRefPattern              = regexp.MustCompile(`^organisations/([^/]+)/messages/([^/]+)$`)
	organisationSharedMailboxMessageRefPattern = regexp.MustCompile(`^organisations/([^/]+)/sharedMailboxes/([^/]+)/messages/([^/]+)$`)
)

// ParseMessageResourceName parses the given resource name to a resource reference.
// Errors for unknown patterns.
func ParseMessageResourceName(resourceName string) (MessageRef, error) {
	if match := userMessageRefPattern.FindStringSubmatch(resourceName); match != nil {
		return MessageRef{
			Parent: MessageParentRef{
				UserId: match[1],
				Type:   UserMessageParentType,
			},
			MessageId: match[2],
		}, nil
	}
	if match := userContextMessageRefPattern.FindStringSubmatch(resourceName); match != nil {
		return MessageRef{
			Parent: MessageParentRef{
				UserId:    match[1],
				ContextId: match[2],
				Type:      UserContextMessageParentType,
			},
			MessageId: match[3],
		}, nil
	}
	if match := organisationMessageRefPattern.FindStringSubmatch(resourceName); match != nil {
		return MessageRef{
			Parent: MessageParentRef{
				OrganisationId: match[1],
				Type:           OrganisationMessageParentType,
			},
			MessageId: match[2],
		}, nil
	}
	if match := organisationSharedMailboxMessageRefPattern.FindStringSubmatch(resourceName); match != nil {
		return MessageRef{
			Parent: MessageParentRef{
				OrganisationId:  match[1],
				SharedMailboxId: match[2],
				Type:            OrganisationSharedMailboxMessageParentType,
			},
			MessageId: match[3],
		}, nil
	}
	return MessageRef{}, errors.New("invalid resource name for resource type 'Message' in service 'messaging.simonbos.be'")
}

// PatientParentType indicates the possible parent types for resource 'Patient'.
type PatientParentType = string

const (
	// PatientRootParentType is a possible parent type for resource 'Patient', used for ”.
	PatientRootParentType PatientParentType = ""
)

// PatientParentRef is the representation of a 'Patient' parent resource name.
// This contains all possible identifiers for all parent types. The Type field implicitly declares the
// identifiers used for that context.
type PatientParentRef struct {
	Type PatientParentType
}

// ResourceName formats r to a resource name.
func (r PatientParentRef) ResourceName() string {
	switch r.Type {
	case PatientRootParentType:
		return fmt.Sprintf("")
	}
	return ""
}

// IsZero reports whether r represents the zero resource reference.
func (r PatientParentRef) IsZero() bool {
	return len(r.Type) != 0
}

var (
	patientPatientParentPattern = regexp.MustCompile(`^$`)
)

// ParsePatientParentResourceName parses the given parent resource name to a parent resource reference.
// Errors for unknown patterns.
func ParsePatientParentResourceName(resourceName string) (PatientParentRef, error) {
	if match := patientPatientParentPattern.FindStringSubmatch(resourceName); match != nil {
		return PatientParentRef{
			Type: PatientRootParentType,
		}, nil
	}
	return PatientParentRef{}, errors.New("invalid parent resource name for resource type 'Patient' in service 'patients.simonbos.be'")
}

// PatientRef is the representation of a 'Patient' resource name.
type PatientRef struct {
	Parent    PatientParentRef
	PatientId string
}

// ResourceName formats r to a resource name.
func (r PatientRef) ResourceName() string {
	switch r.Parent.Type {
	case PatientRootParentType:
		return fmt.Sprintf("patients/%s", r.PatientId)
	}
	return ""
}

// IsZero reports whether r represents the zero resource reference.
func (r PatientRef) IsZero() bool {
	return r.Parent.IsZero() && len(r.PatientId) != 0
}

var (
	patientRefPattern = regexp.MustCompile(`^patients/([^/]+)$`)
)

// ParsePatientResourceName parses the given resource name to a resource reference.
// Errors for unknown patterns.
func ParsePatientResourceName(resourceName string) (PatientRef, error) {
	if match := patientRefPattern.FindStringSubmatch(resourceName); match != nil {
		return PatientRef{
			Parent: PatientParentRef{
				Type: PatientRootParentType,
			},
			PatientId: match[1],
		}, nil
	}
	return PatientRef{}, errors.New("invalid resource name for resource type 'Patient' in service 'patients.simonbos.be'")
}
